#ifndef _rcfile_h
#define _rcfile_h

#define RCDIR ".kwintvrc"
#define CHFILE "default.ch"
#define NEWFORMATVERSION 611

#include <qstring.h>
#include <qtstream.h> 
#include <qrect.h>

class rcfile 
{
public:
  rcfile();
  ~rcfile();

  int load();
  int save();
  bool checkVersion( bool deleteold= true );

  const char * getRCFileName();

public:
  QString country_name;
  QString channelListName;
  QString bttvDeviceName;
  QString ircDataName;
  QString ircDeviceName;
  QString mixerDeviceName;
  QString vc_tempName;
  QString ss_prefix;
  QString dataDir;

  int og_first_time;
  int country_id;
  int mixerDevice;
  int col,hue,bri,contr;
  int delay;
  int norm,in,freq;
  int capture,posOfChannelBox,autoplaceChannelBox;
  int volume_left,volume_right,use_master_volume,sound_on,use_tv_volume;
  int mix_vol_split,mix_bass_split,mix_treble_split;
  int autosave,automouse,autott;
  int screensaver,ss_fixed,ss_width,ss_height,ss_format,ss_quality;
  int aspectRatio,autoar,fixar,border;
  int fs_upper_left,fs_x,fs_y,fs_switch_res,fs_infooverlay,fs_res;
  int vc_audioformat,vc_dimension,vc_format,vc_audiocapture,vc_fps,vc_video_clip,
    vc_channels,vc_bits,vc_rate;
  int vc_width,vc_height;

  int ol_restore,ol_toolbar,ol_menubar,ol_channel,ol_statusbar,ol_tooltips;
  int ol_ch_wasvis, ol_mix_wasvis,ol_allowdocking;
  QRect ol_geometry;
private:

  int version;
};

#endif

